import xbmc,xbmcplugin,os,urlparse,re
import client
import kodi
import dom_parser2
import log_utils
from resources.lib.modules import utils
from resources.lib.modules import helper
buildDirectory = utils.buildDir

filename     = os.path.basename(__file__).split('.')[0]
base_domain  = 'http://www.madthumbs.com'
base_name    = base_domain.replace('www.',''); base_name = re.findall('(?:\/\/|\.)([^.]+)\.',base_name)[0].title()
type         = 'video'
menu_mode    = 208
content_mode = 209
player_mode  = 801

search_tag   = 1
search_base  = urlparse.urljoin(base_domain,'search?q=%s')

@utils.url_dispatcher.register('%s' % menu_mode)
def menu():
    
    url = urlparse.urljoin(base_domain, 'categories')
    r = client.request(url)
    r = dom_parser2.parse_dom(r, 'li', {'id': re.compile('\d+')})
    r = [(dom_parser2.parse_dom(i, 'a', req='href'),dom_parser2.parse_dom(i, 'img', req='src')) for i in r if i]
    r = [(urlparse.urljoin(base_domain,i[0][0].attrs['href']),i[1][0].attrs['title'],i[1][0].attrs['src']) for i in r if i]
    dirlst = []
    
    for i in r:
        try:
            name = kodi.sortX(i[1].encode('utf-8')).title()
            fanarts = xbmc.translatePath(os.path.join('special://home/addons/script.xxxodus.artwork', 'resources/art/%s/fanart.jpg' % filename))
            dirlst.append({'name': name, 'url': i[0], 'mode': content_mode, 'icon': i[2], 'fanart': fanarts, 'folder': True})
        except Exception as e:
            log_utils.log('Error adding menu item %s in %s:: Error: %s' % (i[0].title(),base_name.title(),str(e)), log_utils.LOGERROR)
    
    if dirlst: buildDirectory(dirlst)    
    else:
        kodi.notify(msg='No Menu Items Found')
        quit()
        
@utils.url_dispatcher.register('%s' % content_mode,['url'],['searched'])
def content(url,searched=False):

    r = client.request(url)
    r = re.findall('(<h1.+?)<div class="timewrap">',r,re.DOTALL)
    r = [(dom_parser2.parse_dom(i, 'h1', {'class': 'mtitle'}, req='title'),dom_parser2.parse_dom(i, 'div', {'class': 'thumb_container'})) for i in r if i]
    r = [(i[0][0].attrs['title'],dom_parser2.parse_dom(i[0][0].content, 'a', req='href'), \
        dom_parser2.parse_dom(i[1][0].content, 'img', req='src'))
        for i in r if i[0]]
    r = [(i[0],urlparse.urljoin(base_domain,i[1][0].attrs['href']),i[2][0].attrs['src']) for i in r if i]

    dirlst = []
    
    for i in r:
        try:
            name = kodi.sortX(i[0].encode('utf-8'))
            if searched: description = 'Result provided by %s' % base_name.title()
            else: description = name
            content_url = i[1] + '|SPLIT|%s' % base_name
            fanarts = xbmc.translatePath(os.path.join('special://home/addons/script.xxxodus.artwork', 'resources/art/%s/fanart.jpg' % filename))
            dirlst.append({'name': name, 'url': content_url, 'mode': player_mode, 'icon': i[2], 'fanart': fanarts, 'description': description, 'folder': False})
        except Exception as e:
            log_utils.log('Error adding menu item %s in %s:: Error: %s' % (i[0].title(),base_name.title(),str(e)), log_utils.LOGERROR)
    
    if dirlst: buildDirectory(dirlst, stopend=True, isVideo = True, isDownloadable = True)
    else:
        if (not searched):
            kodi.notify(msg='No Content Found')
            quit()
        
    if searched: return str(len(r))
    
    if not searched:
        search_pattern = '''"\w{4}"\s*\w{4}\=['"]([^\'\"]+)[\'\"]\s*\/>'''
        parse = base_domain
        
        helper.scraper().get_next_page(content_mode,url,search_pattern,filename,parse)